# Contribution guidelines

Thank you for your interest in contributing to this project! There are a few rules to follow in order to ensure quality. If you do not follow the
guidelines, your contribution might be rejected.

1. Make sure to create an issue describing what you would like to do
    - Please wait for a maintainer to approve the proposed changes.
    - If there is already an open issue for the thing you would like to do you just need to claim it ("I would like to work on this") and wait for a
      maintainer to assign the issue to you.
2. Make sure to work in a fork and in a separate branch
    - **Create your branch from the `develop` branch**
    - For features the branch is usually called `feature/my-cool-feature` or `feature-my-cool-feature`.
    - For bugfixes the branch is usually called `fix/my-cool-fix` or `fix-my-cool-fix`.
    - For documentation changes the branch is usually called `docs/my-cool-docs-change` or `docs-my-cool-docs-change`.
3. Only create a pull request if your changes are ready to be reviewed and merged
    - **Merge into `develop`, not `main`**
    - If you want to change something after you have created your pull request please write a small notice in your pr. When you're done, make sure to
      ping a maintainer / request a review.
4. Please use the issue and pull request templates

# Code guidelines

Please follow the [Google Java styleguide](https://google.github.io/styleguide/javaguide.html) and try to match the code style of the rest of the
project. Please also try to document your code, especially in complex and convoluted methods.

### Maintainers

[@cerus](https://github.com/cerus)